package nl.uvt.locator;

import nu.xom.*;

public class IllRequestor {
	Document getDocument( QueryData pQ, LinkInfo linkInfo ){
		Element root = new Element("records");
		Document doc = new Document( root );
		LinkInfo li = generateLink( pQ, linkInfo );
		if ( li != null ){
			Node liNode = li.toRecordNode();
			root.appendChild( liNode );
		}
//		Locator.logger.debug(doc.toXML());
		return doc;
	}

	private LinkInfo generateLink(QueryData pQ, LinkInfo linkInfo ) {
		LinkInfo li = new LinkInfo();
		li.linkMethod = "ILL";
		String db = "";
		String genre = pQ.genre;
		String ppn = pQ.epn.replaceAll(" ", "");
		if ( genre.equals("article") || genre.equals("preprint")){
			db = "2.3";
		}
		else {
			db = "2.4";
		}
// http://picarta.pica.nl/request/FORM/DB=2.3/FORCETT=HTML/REQUEST?PPN=FREE&loanform=C&language=EN&dolocate=Y&genre=article&issn=1557-7740&volume=11&issue=7&oissue=7&spage=1043&pages=1043-5&aulast=Reddy&aufirst=Suresh&auinit1=S&atitle=Opioids+masquerading+as+delirium+in+a+patient+with+cancer+pain+and+obstructive+sleep+apnea.&title=J+Palliat+Med&date=2008&RAPRF=surffederation
		if ( ppn.equals("") ){
			li.generatedUrl = "http://picarta.pica.nl/request/FORM/DB=" + db + 
			    "/FORCETT=HTML/REQUEST?PPN=FREE&loanform=C&language=EN&dolocate=Y&RAPRF=surffederation";
		}
		else {
			li.generatedUrl = "http://picarta.pica.nl/request/FORM/DB=" + db + 
					"/FORCETT=HTML/REQUEST?PPN=" + ppn
					+ "&loanform=C&language=EN&RAPRF=surffederation";
		}
		if ( !pQ.genre.equals("") ) 
			li.generatedUrl += "&genre=" + genre;
		if ( !pQ.issn.equals("") ) 
			li.generatedUrl += "&issn=" + pQ.issn;
		if ( pQ.thVolume > 0  ) 
		  	li.generatedUrl += "&volume=" + pQ.volume;
		if ( !pQ.issue.equals(""))
			li.generatedUrl += "&issue=" + pQ.issue;
		if ( !pQ.spage.equals(""))
			li.generatedUrl += "&spage=" + pQ.spage;
		if ( !pQ.pages.equals("") )
			li.generatedUrl += "&pages=" + pQ.pages;
		if ( !pQ.aulast.equals("") )
			li.generatedUrl += "&aulast=" + pQ.aulast;
		if ( !pQ.aufirst.equals("") )
			li.generatedUrl += "&aufirst=" + pQ.aufirst;
		if ( !pQ.auinit1.equals("") )
			li.generatedUrl += "&auinit1=" + pQ.auinit1;
		if ( !pQ.atitle.equals("") )
			li.generatedUrl += "&atitle=" + pQ.atitle;
		if ( !pQ.title.equals("") )
			li.generatedUrl += "&title=" + pQ.title;
		if ( pQ.year > 0 )
			li.generatedUrl += "&date=" + pQ.year;
		Locator.logger.debug("ILLlink:" + li.generatedUrl);		
		return li;
	}	

}
